(********* Matematica - corso di LPL: Laboratorio 2017 *************)
(*******************************************************************)
(* Definizione del Linguaggio SmallC: Nucleo di C esteso           *)
(* Testing di un Esecutore di SmallC implementato in OCaml         *)
(*******************************************************************)


(*******************************************************************)
(* Functions for inspecting and showing a state					   *) 

let showEnv (rho:env) (list: ide list) =
			List.map (fun x -> (x,getEnv rho x)) list;;
let showStore (Store(n,g)) = 
	 let rec cells inf sup = 
	 		if inf=sup then []
	 		else let l = Loc inf in (l,g l)::(cells (inf+1) sup)
	 in cells 0 n
	 ;;

(*******************************************************************)
(* Functions for extracting from SmallC program declarations, dcl, *)
(* the list of the declared identifiers. 						   *) 

let rec extract dcl = 
	match dcl with
		Const(ide,_) -> [ide]
		| Var(ide,num) -> [ide]
		| VarN ide -> [ide]
		| Array(ide,num) -> [ide]
		| SeqDcl(dcl1,dcl2) -> (extract dcl1)@(extract dcl2)
		| _ -> []
		;;		

(*******************************************************************)
(* Running and State Dump. 						   				   *)
(* Initial state: state0 = (emptyEnv(),emptyStore()) 			   *)

let runDump (p:prog) = 
	let state0 = (emptyEnv(),emptyStore())
	in let (rhoF,muF) = progSem p state0
	   in ((match p with
			   ProgN cmd -> showEnv rhoF []
			   | Program (dcl,cmd) -> showEnv rhoF (extract dcl))
			, showStore muF)
	;; 

